#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Dec 24 15:40:09 2017

@author: boiboite
"""
"------------------algorithme faffi.posi3-----------------------"
"---------------------------------------------------------------"
"---------------------------------------------------------------"
"Représentation graphique, algorithme faffi.posi3 en lignes de commandes"
"Importation des bibliothèques suffisantes"
import numpy as np


m = -2 ; p = 3 ; a = -4 ; b = 4 ; nbpoints = 9
def f(x):
    return m * x + p

"Calcul des abscisses et des ordonnées des nbpoints points"
"Ce sont des 'array' car on utilise np"
"Sans numpy on ne peut pas faire y = m * x + p, il faudrait faire une boucle"
x = np.linspace(a, b, nbpoints)
y = f(x)

"Un seul tableau (1 ligne) contient les couleurs de chaque point"
"Scatter permet d'affecter une couleur à chaque point avec une liste scy"
"    des couleurs des points de f,  en paramètre"
"Dommage qu'on ne puisse pas faire la même chose avec les markers !!"
couleur = ('green', 'blue')
signy = (y < 0) * 1
scy = [couleur[i] for i in signy]

from matplotlib import pyplot as plt
plt.figure()
plt.scatter(x, y, s = 50, marker = 'o', color = scy, edgecolors = 'none')
plt.plot(x, [0] * nbpoints, 'r-')
plt.title('Représentation graphique de la fonction affine f')
plt.xlabel('Abscisses X')
plt.ylabel('Ordonnées Y')
plt.text(min(x), max(y), 'f négative en bleu\nf positive en vert',
         verticalalignment = 'top', horizontalalignment = 'left')
plt.grid() ; plt.show()


"---------------------------------------------------------------"
"Une fonction Python3 correspondant à l'algorithme faffi.posi3"
def SigneAffine3(m = -2, p = 3, a = -5, b = 5, nbpoints = 20):
    import numpy as np
    import matplotlib.pyplot as plt
    def f(x):
        return m * x + p














    plt.show()
    

"---------------------------------------------------------------"
"---------------------------------------------------------------"
"---------------------------------------------------------------"
"Représentation graphique de l'équation f(x) < k avec f(x) = mx + p sur [a ; b]"
"C'est à dire la position de la droite représentative de la fonction affine f,"
"    par rapport à la droite d'équation y = k"
"L'objectif est de représenter différemment les points d'ordonnées y inférieures à k"
"    de ceux d'ordonnées supérieures à k, soit par la couleur, soit par les marques."
"---------------------------------------------------------------"
"Une fonction Python3 correspondant à l'algorithme faffi.posi4"
def PosikAffine4(k = 1, m = -2, p = 3, a = -5, b = 5, nbpoints = 20):
    import numpy as np
    import matplotlib.pyplot as plt







    plt.figure()
    plt.scatter(x, y, s = 15, marker = 'o', color = scy, edgecolors = 'none')
    plt.plot(x, [k] * nbpoints, 'r-')
    plt.title('Représentation graphique de la fonction affine f')
    plt.xlabel('Abscisses X')
    plt.ylabel('Ordonnées Y')
    plt.text((min(x) + max(x)) / 2, max(y), 'f inférieure à k en bleu\nf supérieure à k en vert',
         verticalalignment = 'top', horizontalalignment = 'center')
    plt.grid()
    plt.show()


"---------------------------------------------------------------"
"---------------------------------------------------------------"
"---------------------------------------------------------------"
"soit f et g deux fonctions affines définies sur l'intervalle [a ; b]"
"L'objectif est d'illustrer les positions relatives des deux droites"
"    représentatives des fonctions affine f et g"
"Il s'agit donc de représenter différemment les points d'ordonnées y inférieures à k"
"    de ceux d'ordonnées supérieures à k, soit par la couleur, soit par les marques."
"---------------------------------------------------------------"
"Une fonction Python3 correspondant à l'algorithme faffi.posi5"
def PositAffine5(mf = -2, pf = 3, mg = 3, pg = -4, a = -5, b = 5, nbpoints = 20):
    import numpy as np
    import matplotlib.pyplot as plt










    plt.figure()
    plt.plot(x, y, ls = '-', color = 'black', label = 'Fonction f')
    plt.scatter(x, z, s = 20, marker = '+', color = scy, edgecolors = 'none', label = 'Fonction g')
    plt.title('Représentation graphique des fonctions affines f et g')
    plt.xlabel('Abscisses X')
    plt.ylabel('Ordonnées Y')
    plt.text((min(x) + max(x)) / 2, max(max(y), max(z)), 'g inférieure à f en bleu\ng supérieure à f en vert',
             verticalalignment = 'top', horizontalalignment = 'center')
    plt.grid()
    plt.legend(loc = 'center left')
    plt.show()



