#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Dec 16 01:48:32 2017

@author: bubu
"""

"------------------- ALGO S3-1 ----------------------------------"
"Distribution simulée de la somme S3d des faces de trois dés à 6 faces équilibrées"
"Le tableau des effectifs est construit au fur et à mesure des lancers."
"Le lancer des dés est fait dans une boucle et l'effectif des numéros obtenus"
"    augmente de 1 à chaque tour."
"La liste des effectifs des 16 valeurs (3 à 18) est initialisée à 0."
from random import randint


"Nombre de simulations"
nbsim = 5000

"Initialisation à 0, de la série des effectifs des 16 sommes possibles"
serieEffectifs = [0] * 16
serieEffectifs

"nbsim simulations du lancer de 3 dés. Somme des 3 valeurs obtenues"
for n in range(nbsim):
    de1 = randint(1, 6)
    de2 = randint(1, 6)
    de3 = randint(1, 6)
    troisDes = de1 + de2 + de3
    "Les effectifs des sommes obtenues sont cumulés dans serieEffec"
    serieEffectifs[troisDes - 3] += 1
serieEffectifs

"Construction et affichage du 'tableau' des effectifs, S3di, ni"
tabloEffec = dict(zip(range(3, 19), serieEffectifs))
tabloEffec

"Construction et affichage du 'tableau'des fréquences, S3di, fi"
serieFreq = tuple(round(serieEffectifs[i] / nbsim, 4) for i in range(16))
serieFreq

tabloFreq = dict(zip(range(3, 19), serieFreq))
tabloFreq

"-----Le graphique en barres du tableau des fréquences simulées------"
x = range(3, 19)
from matplotlib import pyplot as plt
plt.figure()
plt.bar(x, serieFreq, color = 'green') ; plt.xticks(x)
plt.title("DISTRIBUTION SIMULÉE DE LA VARIABLE S3d")
plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
plt.ylabel("FRÉQUENCE SIMULÉE")
plt.grid()
plt.grid() ; plt.show()

"---------------- ALGO S3-1 ---------------------------------------"
"Une fonction python correspondant"
def S3d_1(nbsim):
    from random import randint
    from matplotlib import pyplot as plt
	
	
	
	
	
   
   
   
   
   
   
   
    "-----Le graphique en barres du tableau des fréquences simulées------"
    x = range(3, 19)
    plt.figure()
    plt.grid()
    plt.bar(x, serieFreq, color = 'green') ; plt.xticks(x)
    plt.title("DISTRIBUTION SIMULÉE DE LA VARIABLE S3d")
    plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
    plt.ylabel("FRÉQUENCE SIMULÉE")
    plt.grid()
    plt.show()


"---------------- LA DISTRIBUTION DE PROBABILITÉS------------------"
"---------------- ALGO P-S3-1 ---------------------------------------"
"Univers de la variable aléatoire S3d : somme des faces de trois dés équilibrés à six faces"
"Tableau des effectifs des valeurs de la v.a. S3d"
"Distribution de probabilité de la v.a. S3d"

"Liste des  6x6x6=216 triplets obtenus en lançant 3 dés"
UniversTriplets = tuple((i, j, k) for i in range(1, 7) for j in range(1, 7) for k in range(1, 7))
"J'affiche la liste des 8 premiers triplets obtenus"
UniversTriplets[0:7]

"Cardinal de l'univers = longueur de la liste UnivTriplets"
cardUniversTriplets = len(UniversTriplets)

"J'utilise UniversTriplets pour faire la somme de chacun des 216 triplets"
UnivS3d = tuple(sum(UniversTriplets[i]) for i in range(cardUniversTriplets))
"J''affiche la liste des 8 premières sommes obtenues"
UnivS3d[0:7]

"Initialisation à 0 de la liste des effectifs des valeurs de la v.a. S3d"
listeEff = [0] * 16
listeEff

"Création de la liste des effectifs des valeurs de S3d"
for k in range(cardUniversTriplets):
    listeEff[UnivS3d[k] - 3] += 1
"J'affiche la liste des effectifs des 8 premières valeurs"
listeEff[0:7]

"Calcul des probabilités des valeurs de S3d"
Proba = tuple(round(listeEff[i] / cardUniversTriplets, 4) for i in range(16))
"J'affiche la liste des probabilités des 8 premières valeurs"
Proba[0:7]

"Création du tableau de la distribution des effectifs de S3d"
tabloEffec = dict(zip(range(3, 19), listeEff))
"J'affiche le tablo des effectifs"
tabloEffec

"Création du tableau de la distribution de probabilité de S3d"
tabloProba = dict(zip(range(3, 19), Proba))
"J'affiche le tablo des probabilités"
tabloProba

"-----Le graphique en barres de la distribution de probabilité de S3d -----"
from matplotlib import pyplot as plt
x = range(3, 19)
plt.figure()
plt.bar(x, Proba) ; plt.xticks(x)
plt.title("DISTRIBUTION DE PROBABILITÉ DE LA VARIABLE S3d")
plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
plt.ylabel("PROBABILITÉ")
plt.grid()
plt.show()

"---------------- ALGO P-S3-1 ---------------------------------------"
"Une fonction python correspondant"
def probaS3d():
    from matplotlib import pyplot as plt
    
    
    
    
    
    
    
    
    x = range(3, 19)
    plt.figure()
    plt.bar(x, Proba) ; plt.xticks(x)
    plt.title("DISTRIBUTION DE PROBABILITÉ DE LA VARIABLE S3d")
    plt.xlabel("VALEURS DE S3d SOMME DES TROIS CHIFFRES OBTENUS")
    plt.ylabel("PROBABILITÉ")
    plt.grid()
    plt.show()




